% APT2PB 

include "SybaseSQL.grm"
include "SybAPT.grm"

function main
    replace [program]
        P [repeat apt_statement]
    by
        P [fix_variable_statement] 
          [fix_if_statement] [fix_while_statement]
          [fix_foreach_statement] [fix_foreach_sqlrow]
          [fix_std_select_adddual] [fix_std_select_statement]
          [fix_groups] [fix_isNull] [fix_isNOTNull] [fix_setNull]
          [fix_callform_msgbox_1] [fix_append]
          [fix_positionform_curfield] 
          [fix_positionform_onefield] 
          [fix_positionform_grpfield]
          [fix_not_equal]
end function

% rule fix_variable_statement
% rule fix_if_statement
% rule fix_groups
% rule fix_isNull
% rule fix_isNOTNull
% rule fix_setNull
% rule fix_not_equal
% rule fix_callform_msgbox_1
% rule fix_append
% rule fix_positionform_curfield
% rule fix_positionform_onefield
% rule fix_positionform_grpfield
% rule fix_while_statement
% rule fix_foreach_statement
% rule fix_foreach_sqlrow
% rule fix_std_select_adddual
% rule fix_std_select_statement

rule fix_variable_statement
    replace [variable_statement] 
        VSTMT [variable_statement] 
    deconstruct * [list var_declare] VSTMT
        APTVARLIST [list var_declare]  
    construct PBVARLIST [repeat var_declare]  
        _ [changeVarStmt each APTVARLIST]         
    construct PBVSTMT [variable_statement]  
        PBVARLIST 
    by
        PBVSTMT
end rule

function changeVarStmt APTVARDECL [var_declare]
    replace [repeat var_declare]
    SoFar [repeat var_declare]
    
    construct PBVARDECL [var_declare]
    APTVARDECL [splitonevar]
    by
    SoFar [. PBVARDECL]
end function


function splitonevar 
    replace [var_declare]
       APTVARDECL [var_declare]
    deconstruct * [nosize_declare] APTVARDECL
        ONEVAR [id] ONETYPE [data_type]
    construct PBVARDECL  [var_declare]    
        ONETYPE [change_type_PB] ONEVAR    
    by
        PBVARDECL
end function

function change_type_PB
    construct AptTypes [repeat data_type]
        'binary   'bit      'char    'datetime  'float         'int 
        'money    'smallint 'tinyint 'varchar   'smalldatetime 'smallmoney
    construct PBTypes [repeat data_type]
        'BLOB     'int      'string 'datetime    'decimal       'long 
        'decimal  'int      'int     'string     'datetime     'decimal          
    replace [data_type]
        ONETYPE [data_type]
    by
        ONETYPE [$ each AptTypes PBTypes]
end function

rule fix_if_statement
    replace [apt_statement]
        IFSTMT [apt_statement]
    deconstruct IFSTMT 
        'if SRCHCOND [search_condition] 
            APTSTMT [apt_statement] 
            APTELSESTMT [opt apt_else_statement]
    construct PBPART1 [repeat apt_statement]
        _ [. APTSTMT ]
    construct PBPART2 [opt pb_else_statement] 
        _ [buildPBelse  APTELSESTMT]    
    by
        'if SRCHCOND 'then
            PBPART1 PBPART2 'end 'if
end rule

function buildPBelse  APTELSESTMT [opt apt_else_statement]
    replace [opt pb_else_statement]   
        _ [opt pb_else_statement] 
    deconstruct  APTELSESTMT 
        'else THEELSE [apt_statement] 
    construct PBELSE [repeat apt_statement]
        _ [. THEELSE]        
    by
        'else PBELSE        
end function   

% Assumption 1 group per form
rule fix_groups
    replace * [apt_id]
        APTID [apt_id]
    deconstruct APTID
        ID1 [apt_id] '[ ID2 [dollar_variable] '] '. FIELD [id]
    construct NEWID [id]
       _
    by
        'dwgrp.Object. FIELD '[ NEWID [unquote "row"] ']
end rule

rule fix_isNull
    replace * [search_condition]
        APTID [apt_id] 'Is 'null 
    by
        'IsNull '( APTID ') 
end rule

rule fix_isNOTNull
    replace * [search_condition]
        APTID [apt_id] 'Is 'NOT 'null 
    by
        'NOT 'IsNull '( APTID ') 
end rule

rule fix_setNull
    replace * [assignment]
        APTID [apt_id] '= 'null 
    by
        'SetNull '( APTID ') 
end rule

rule fix_not_equal
    replace * [sql_comparison]
        '!= 
    by
        '<> 
end rule

rule fix_callform_msgbox_1
    replace [apt_statement]
        'callform 'msgbox_1
    by
        'MessageBox("Please_Note",mssg)
end rule

rule fix_append
    replace * [apt_statement]
        'append APTID [apt_id] 
%   deconstruct APPENDSTMT
%       'append GROUP [dollar_variable]
    by
        'll_ret=dwgrp.InsertRow(0)
end rule

rule fix_positionform_curfield
    replace [apt_statement]
        POSITIONFORMSTMT [apt_statement]
    deconstruct POSITIONFORMSTMT
        'positionform VAR [dollar_variable]
    construct SVAR [stringlit]
        _ [unparse VAR]
    where 
        SVAR [= "$curfield" ]
    by
        'this.setFocus()
end rule

rule fix_positionform_onefield
    replace [apt_statement]
        POSITIONFORMSTMT [apt_statement]
    deconstruct POSITIONFORMSTMT
        'positionform VAR [id]
    by
         VAR '. setFocus()
end rule

rule fix_positionform_grpfield
    replace [apt_statement]
        POSITIONFORMSTMT [apt_statement]
    deconstruct POSITIONFORMSTMT
        'positionform VAR [id]
    by
         VAR '.setFocus()
end rule

rule fix_while_statement
    replace [apt_statement]
        WHILESTMT [apt_statement]
    deconstruct WHILESTMT 
        'while SRCHCOND [search_condition] 
            APTSTMT [apt_statement] 
    construct PBPART1 [repeat apt_statement]
        _ [. APTSTMT ]
    by
        'do 'while SRCHCOND  
            PBPART1
        'loop  
end rule

rule fix_foreach_statement
    replace [apt_statement]
        FOREACHSTMT [apt_statement]
    deconstruct FOREACHSTMT 
        'foreach ID [id] 'in APTID [apt_id] 
        APTSTMT [apt_statement]
    construct PBPART1 [repeat apt_statement]
        _ [. APTSTMT ]
    by
        'foreach ID 'in APTID   
            PBPART1
        'next  
end rule

rule fix_foreach_sqlrow
    replace [apt_statement]
        FOREACHSQLROW [apt_statement]
    deconstruct FOREACHSQLROW 
        'foreach ID [id] 
        APTSTMT [apt_statement]
    construct PBPART1 [repeat apt_statement]
        _ [. APTSTMT ]
    by
        'foreach ID 
            PBPART1
        'next  
end rule

rule fix_std_select_adddual
    replace [std_select_statement]
        SELSTMT [std_select_statement]
    deconstruct SELSTMT         
        'select OPTTBL [opt into_table] OPTALLDIS [opt all_distinct] 
                SEL [selection] 
                TBLEXP  [opt table_exp]
                OPTCOMP [opt compute_clause] 
    deconstruct not * [from_clause] TBLEXP
        'from LSTTBL [list table_ref] 
    by
        'select OPTTBL OPTALLDIS 
                SEL 
                'from 'dual
                OPTCOMP 
end rule

rule fix_std_select_statement
    replace [std_select_statement]
        SELSTMT [std_select_statement]
    deconstruct SELSTMT         
        'select OPTTBL [opt into_table] OPTALLDIS [opt all_distinct] 
                SEL [selection] 
                TBLEXP  [opt table_exp]
                OPTCOMP [opt compute_clause] 
    deconstruct SEL
        LSTSEL [list selection_exp]
    construct NEWSEL [list selection_exp]  
        _ [buildColumn each LSTSEL ]
    construct NEWLST [list column_ref]
        _ [buildInto   each LSTSEL ] 
    construct KLSTSEL [number]
        _ [length LSTSEL]
    construct KNEWSEL [number]
        _ [length NEWSEL]
    construct KNEWLST [number]
        _ [length NEWLST] 
    where all
        KLSTSEL [= KNEWSEL] [= KNEWLST]        
    by
        'select OPTTBL OPTALLDIS 
                NEWSEL 
                'into NEWLST 
                TBLEXP 
                OPTCOMP 
end rule


function buildColumn OneSel [selection_exp] 
    replace [list selection_exp] 
        SoFar [list selection_exp]  
    deconstruct * [assignment] OneSel 
        COL [apt_id] '= EXP [scalar_exp]
    construct NEWEXP [selection_exp]
        EXP       
    by
        SoFar [, NEWEXP]
        
end function

function buildInto OneSel [selection_exp]  
    replace [list column_ref]
        SoFar  [list column_ref]
    deconstruct * [assignment] OneSel 
        COL [apt_id] '= EXP [scalar_exp]
    construct  NEWCOL [column_ref]
        COL
    by
        SoFar [, NEWCOL]
end function

   