SET QUOTED_IDENTIFIER ON 
GO
SET ANSI_NULLS ON 
GO


Create Proc SybRepSQL (
@name    varchar(30)
)
As
Begin

create table #t1
( rptid     int,
  batid     int,
  entryid   int,
  orderid   int,
  work      varchar(1000)
)

    insert into #t1
    select rptid, -1, 0, 0, 'print char(10) + replicate(''='',100) + char(10)' + char(10) +
                            'print ''RPTID=' + convert(varchar(4),rptid) +
                            ' NAME=' + @name + ''''
      from syb_reports
     where name = @name

    insert into #t1
    select r.rptid, b.batid, b.entryid, -1, b.sqltext
      from syb_reports r, syb_batches b
     where r.rptid = b.rptid
       and r.name = @name

    insert into #t1
    select r.rptid, b.batid, b.entryid, t.orderid, t.value
      from syb_reports r, syb_batches b, syb_texts t
     where r.rptid   = b.rptid
       and r.rptid   = t.rptid
       and b.rptid   = t.rptid
       and b.entryid = t.entryid
       and r.name    = @name

    insert into #t1
    select r.rptid, 99, 99, l.lytid,
           'print char(10) + replicate(''-'',100) + char(10)' + char(10) +
           'print ''BAND=' + upper(l.name) +
           '  rptid='  + @name  +
           '  layout=' + convert(varchar(4),l.lytid)  +
           '  lines='  + convert(varchar(4),l.height) + '''' + char(10) +
           'exec sybrep2pb @rptid=' + convert(varchar(4),r.rptid)  +
                        ', @lytid=' + convert(varchar(4),l.lytid)  +
                        ', @lines=' + convert(varchar(4),l.height) +
                        '  -- '     + l.name
      from syb_reports r, syb_layouts l
    where r.rptid   = l.rptid
      and r.name = @name
      and l.height !=0

    Select work
      from #t1
     order by rptid, batid, entryid, orderid

    drop table #t1


End

GO
SET QUOTED_IDENTIFIER OFF 
GO
SET ANSI_NULLS ON 
GO

